{****************************************************************************}
program airport;
{****************************************************************************}
uses crt,graph;
{****************************************************************************}
type plane=record
           company:integer;
           takeoff:boolean;
           time: real;
           vip:boolean;
           vipname:string[20];
           country:integer;
           end;
     options=array[1..25] of string[30]; {menu options type}
     groupptr=^groupofplanes;
     groupofplanes=record
           aeroplane:plane;
           next:groupptr;
           end;
     planeimage=array[1..1414] of integer;
     coordinates=record
          x,y:integer;
          end;
     tempstring= string[79];
{****************************************************************************}
var day: array[1..48] of plane;
    airway: array[1..2,1..96] of plane;
    postponed: array[1..48] of groupptr;
    maxindex,planesno,choice: integer;
    companies: array[1..4] of string[20];
    menuoptions,countries: options;
    coords:array [1..23] of coordinates;
    widths:array[1..10] of integer;
    checks:array[1..10] of boolean;
    tempfile: text;
{****************************************************************************}
procedure initialize_graph;
var g,gd:integer;
begin
g:=VGA;gd:=VGAHI;
initgraph(g,gd,'c:\tp\bgi');
setrgbpalette(GREEN,37,37,37);
end;
{****************************************************************************}
procedure clear_keyboard_buffer;
begin
while(keypressed) do write(readkey);
end;
{****************************************************************************}
function input_text(x1,y1,size:integer):string;
var ex:boolean;
    ch:char;
    index:integer;
    st:string;
begin
settextstyle(1,0,2);
st:='';
ex:=false;
index:=1;
if size=8 then st:='Demo';
while (not ex) do
      begin
      setcolor(WHITE);
      outtextxy(x1,y1,st);
      ch:=readkey;
      if (ch>='0') and (ch<='z') and (ord(st[0])<size) then
                      st:=st+ch;
         if (ch=chr(8)) and (st[0]<>#0) then {delete pressed}
            begin
            setcolor(BLACK);
            outtextxy(x1,y1,st);
            dec(st[0])
            end;
         if (ch=chr(13)) and (st<>#0) then {enter pressed}
            ex:=true;
          end;
input_text:=st;
end;
{****************************************************************************}
procedure load_map(x,y:integer);
type img=array[1..8390] of integer;
var fptr:FILE of img;
    mapimg:^img;
    a:integer;
begin
assign(fptr,'map.dat');
reset(fptr);
new(mapimg);
read(fptr,mapimg^);
putimage(x,y,mapimg^,COPYPUT);
putimage(x+248,y,mapimg^[8126],COPYPUT);
close(fptr);
dispose(mapimg);
end;
{****************************************************************************}
procedure frame3d(x1,y1,x2,y2,c1,c2:integer);
begin
setcolor(c1);setlinestyle(0,0,1);
line(x1,y1,x2,y1);line(x1+3,y1+3,x2-3,y1+3);line(x2-3,y1+3,x2,y1);
line(x1,y1,x1,y2-1);line(x1,y2-1,x1+3,y2-4);line(x1+3,y2-4,x1+3,y1+3);
setfillstyle(1,c1);floodfill(x1+1,y1+1,c1);
setcolor(c2);
line(x1,y2,x2,y2);line(x2,y2,x2,y1+1);line(x2,y1+1,x2-3,y1+4);
line(x2-3,y1+4,x2-3,y2-3);line(x2-3,y2-3,x1+3,y2-3);line(x1+3,y2-3,x1,y2);
setfillstyle(1,c2);floodfill(x2-1,y1+5,c2);
end;
{****************************************************************************}
procedure rotate_map;
type img=array[1..8390] of integer;
var mapimg:^img;
    a:integer;
begin
new(mapimg);
getimage(195,175,195+247,175+130,mapimg^[1]);
getimage(195+247+1,175,195+247+5,175+130,mapimg^[8126]);
putimage(200,175,mapimg^[1],COPYPUT);
putimage(195,175,mapimg^[8126],COPYPUT);
dispose(mapimg);
end;
{****************************************************************************}
procedure intro;
type tone=record
     freq,delay:integer;
     end;
var  f:file of tone;
    elhelwa:array[1..78] of tone;
    ton:tone;
    i,divs,j:integer;
begin
initialize_graph;
setfillstyle(1,green);
bar(0,0,639,479);
setcolor(LIGHTGRAY);rectangle(21,21,620,459);
setcolor(DARKGRAY);rectangle(20,20,619,458);
settextstyle(1,0,7);
setcolor(LIGHTGRAY);outtextxy(48,20,'Airport Simulator');
setcolor(darkGRAY);outtextxy(47,19,'Airport Simulator');
setcolor(0);outtextxy(46,18,'Airport Simulator');
setcolor(blue);outtextxy(285,80,'By');
settextstyle(1,0,5);
setcolor(LIghtred);outtextxy(91,350,'Ahmed Mohamed Reda');
setcolor(red);outtextxy(90,349,'Ahmed Mohamed Reda');
load_map(195,175);
assign(f,'topas');
reset(f);
for i:=1 to 78 do read(f,elhelwa[i]);close(f);
frame3d(0,0,639,479,lightgray,darkgray);
frame3d(190,170,452,310,darkgray,lightgray);
i:=0;
while(not keypressed) do
begin
i:=i+1;
if i=78 then i:=1;
case elhelwa[i].delay of
     10: divs:=4;
     5: divs:=2;
     2: divs:=1;
     end;
for j:=1 to divs do begin
    sound(elhelwa[i].freq);
    rotate_map;
    end;
end;
nosound;
clear_keyboard_buffer;
end;
{****************************************************************************}
procedure display_item(x,y,width,no,col:integer;items:options);
var i:integer;
begin
textbackground(col);
gotoxy(x+1,y+no);write(items[no]);
for i:=1 to width-length(items[no]) do write(' ');
end;
{****************************************************************************}
procedure time2str(time:real;var timestr:string);
var tst:string;
begin
str(trunc(time),timestr);timestr:=timestr+':';
if time>trunc(time) then
                    begin
                    str(30,tst);
                    timestr:=timestr+tst;
                    end
else timestr:=timestr+'00';
end;
{****************************************************************************}
procedure frame(x1,y1,x2,y2,col:integer);
var i,j:integer;
begin
textbackground(col);
gotoxy(x1,y1);
write(chr(201));for i:=x1 to x2-2 do write(chr(205));write(chr(187));
for i:=y1 to y2-2 do
    begin
    gotoxy(x1,i+1);write(chr(186));for j:=x1+1 to x2-1 do write(' ');write(chr(186));
    end;
gotoxy(x1,i+2);
write(chr(200));for i:=x1 to x2-2 do write(chr(205));write(chr(188));
end;
{****************************************************************************}
procedure wait4akey;
var ch:char;
begin
if readkey=chr(0) then ch:=readkey;
end;
{****************************************************************************}
function menu(x,y,width,items_no:integer;items:options): integer;
var i,a,choice:integer;
    ch:char;
    bail:boolean;
begin
gotoxy(x,y);textbackground(BLUE);
write(chr(201));for i:=1 to width do write(chr(205));write(chr(187));
for i:=1 to items_no do
    begin
    gotoxy(x,y+i);write(chr(186));
    display_item(x,y,width,i,BLUE,items);
    gotoxy(x+width+1,y+i);write(chr(186));
    end;
gotoxy(x,y+i+1);
write(chr(200));for i:=1 to width do write(chr(205));write(chr(188));
choice:=1;
display_item(x,y,width,1,RED,items);
bail:=FALSE;
while bail<>TRUE do
      begin
      ch:=readkey;
      case ch of
           chr(0): begin
                   ch:=readkey;
                   case ch of
                   'H': {up awwow!! (I've problem with the letter r!) :-) <g>}
                       begin
                       display_item(x,y,width,choice,BLUE,items);
                       if choice=1 then choice:=items_no else choice:=choice-1;
                       display_item(x,y,width,choice,RED,items);
                       end;
                   'P': {down awwow}
                       begin
                       display_item(x,y,width,choice,BLUE,items);
                       if choice=items_no then choice:=1 else choice:=choice+1;
                       display_item(x,y,width,choice,RED,items);
                       end;
                   end;
                   end;
           chr(13): bail:=TRUE;
           chr(27): begin choice:=27;bail:=TRUE;end;
           {Escape reached :(((((}
      end;
      end;
menu:=choice;
end;
{****************************************************************************}
procedure display_time(x,y,hours,minutes:integer);
begin
              gotoxy(x,y);
              if hours<10 then write('0');
              write(hours,':',minutes);
              if minutes=0 then write('0');
end;
{****************************************************************************}
procedure get_time(x,y:integer;var hours,minutes:integer);
var ch:char;
    bail:boolean;
begin
bail:=false;
hours:=0;minutes:=30;
frame(x,y,x+7,y+2,BLUE);
gotoxy(x+1,y+1);write('00:30');
while(bail=false) do
           begin
           ch:=readkey;
           if (ch >= '0') and (ch<='9') then hours:=ord(ch)-ord('0');
           if ch=char(13) then bail:=true;
           if ch=char(0) then
              begin
              ch:=readkey;
              case ch of
                   'H': begin
                        minutes:=minutes+30;
                        hours:=hours+minutes div 60;
                        if hours=24 then begin hours:=0;minutes:=30;end;
                        minutes:=minutes mod 60;
                        end;
                   'P': if not((minutes=30) and (hours=0)) then
                        begin
                        minutes:=minutes-30;
                        hours:=hours+minutes div 60;
                        if minutes<0 then begin hours:=hours-1;minutes:=30;end;
                        minutes:=minutes mod 60;
                        end
                        else begin hours:=23;minutes:=30; end;
                   end;
              end;
              hours:=hours mod 24;
              display_time(x+1,y+1,hours,minutes);
              end;
end;
{****************************************************************************}
procedure add_plane(planeno:integer);
var t,hours,minutes,temp:integer;
    buffer:array[1..1000] of integer;
begin
planesno:=planesno+1;
temp:=planesno;
if planeno<>0 then begin planesno:=planeno;dec(temp);end;
for t:=1 to 4 do menuoptions[t]:=companies[t];
textbackground(RED);gotoxy(3,2);write('Plane Company');
day[planesno].company:=menu(3,3,15,4,menuoptions);
menuoptions[1]:='Departing';
menuoptions[2]:='Arriving';
gotoxy(20,2);write('A./D.');
t:=menu(20,3,15,2,menuoptions);
if t=1 then day[planesno].takeoff:=true else day[planesno].takeoff:=false;
for t:=1 to 21 do menuoptions[t]:=countries[t];
gotoxy(37,2);write('Country');
day[planesno].country:=menu(37,3,15,21,menuoptions);
gotoxy(54,2);write('Time');
get_time(54,3,hours,minutes);
day[planesno].time:=hours+minutes/60;
menuoptions[1]:='Yes';
menuoptions[2]:='No';
textbackground(RED);
gotoxy(62,2);write('VIP?');
t:=menu(62,3,15,2,menuoptions);
if t=1 then
   begin
   day[planesno].vip:=true;
   frame(54,10,80,13,BLUE);
   gotoxy(55,11);textbackground(RED);writeln('Please type his name');
   textbackground(BLACK);gotoxy(56,12);
   for t:=1 to 22 do write(' ');
   gotoxy(56,12);
   readln(day[planesno].vipname);
   end
else day[planesno].vip:=false;
planesno:=temp
end;
{****************************************************************************}
procedure transline(x,y,width:integer);
var i:integer;
begin
gotoxy(x,y);write(chr(204));
for i:=1 to width-2 do write(chr(205));
write(chr(185));
end;
{****************************************************************************}
procedure vertline(x,y,length,c1,c2:integer);
var i:integer;
begin
gotoxy(x,y);write(chr(c1));
for i:=1 to length-2 do begin gotoxy(x,y+i);write(chr(186));end;
gotoxy(x,y+i+1);write(chr(c2));
end;
{****************************************************************************}
procedure display_planes;
var i:integer;
    timestr:string;
begin
initialize_graph;
setfillstyle(1,Yellow);bar(0,0,639,30);
setfillstyle(1,WHITE);bar(0,30,639,450);
setfillstyle(1,yellow);bar(0,450,639,479);
setcolor(MAGENTA);rectangle(0,0,639,479);
line(40,0,40,450);
line(0,30,639,30);line(140,0,140,450);line(220,0,220,450);
line(300,0,300,450);line(400,0,400,450);line(500,0,500,450);
for i:=0 to 21 do line(0,i*20+30,639,i*20+30);
setcolor(RED);
outtextxy(16,10,'No.');
outtextxy(60,10,'Company');outtextxy(155,10,'Arrival');
outtextxy(225,10,'Departure');outtextxy(305,10,'Coming from');
outtextxy(408,10,'Destination');outtextxy(515,10,'VIP character');
setcolor(BLUE);outtextxy(230,459,'Press any key to continue');
for i:=1 to planesno do
    begin
    str(i,timestr);
    outtextxy(18,i*20+16,timestr);
    outtextxy(58,i*20+16,companies[day[i].company]);
    time2str(day[i].time,timestr);
    if day[i].takeoff=true then
       begin
       outtextxy(240,i*20+16,timestr);
       outtextxy(410,i*20+16,countries[day[i].country]);
       outtextxy(310,i*20+16,'Egypt');
       end else
       begin
       outtextxy(156,i*20+16,timestr);
       outtextxy(310,i*20+16,countries[day[i].country]);
       outtextxy(410,i*20+16,'Egypt');
       end;
    if day[i].vip=true then outtextxy(510,i*20+16,day[i].vipname)
    else outtextxy(510,i*20+16,'none');
    end;
end;
{****************************************************************************}
procedure edit_plane;
var st:string[3];
    t,planeno:integer;
begin
display_planes;
setfillstyle(1,yellow);bar(0,450,639,479);
setcolor(BLUE);outtextxy(130,459,'Enter plane no. to edit:');
setfillstyle(1,0);bar(360,453,400,477);
setcolor(RED);rectangle(360,453,400,477);
st:=input_text(365,452,2);
val(st,planeno,t);
textmode(3);
add_plane(planeno);
end;
{****************************************************************************}
procedure delete_plane;
var st:string[3];
    t,i,planeno:integer;
begin
display_planes;
setfillstyle(1,yellow);bar(0,450,639,479);
setcolor(BLUE);outtextxy(130,459,'Enter plane no. to delete:');
setfillstyle(1,0);bar(360,453,400,477);
setcolor(RED);rectangle(360,453,400,477);
st:=input_text(365,452,2);
val(st,planeno,t);
for i:=planeno to planesno-1 do
    day[i]:=day[i+1];
dec(planesno);
end;
{****************************************************************************}
procedure save_day(fn:string);
var fptr:file of plane;
    i:integer;
begin
assign(fptr,fn);
rewrite(fptr);
for i:=1 to planesno do write(fptr,day[i]);
close(fptr);
end;
{****************************************************************************}
procedure load_day(fn:string);
var fptr:file of plane;
begin
planesno:=0;
assign(fptr,fn);
reset(fptr);
while not eof(fptr) do
      begin
      planesno:=planesno+1;
      read(fptr,day[planesno]);
      end;
      close(fptr);
end;
{****************************************************************************}
procedure initb4sim;
var i,j:integer;
begin
for i:=1 to 2 do
    for j:=1 to 96 do
        airway[i][j].company:=0;
for i:=1 to 48 do postponed[i]:=nil;
end;
{****************************************************************************}
procedure postpone(aeroplane:plane;index:integer);
var ptr:groupptr;
begin
ptr:=postponed[index];
if ptr=nil then begin
                new(postponed[index]);
                postponed[index]^.next:=nil;
                postponed[index]^.aeroplane:=aeroplane;
                end
else
    begin
    while ptr^.next<>nil do ptr:=ptr^.next;
    new(ptr^.next);
    ptr^.next^.next:=nil;
    ptr^.next^.aeroplane:=aeroplane;
    end;
end;
{****************************************************************************}
procedure arrange_airways;
var minviptime:real;
    i,j,k,index,vipno,nonvipno:integer;
    found:boolean;
    nonvipplanes,vipplanes:array[1..48] of plane;
    tempplane:plane;
begin
initb4sim; {initialize the airway and the postponed list}
{put vip/nonvip planes in separate arrays}
maxindex:=0;
vipno:=0;nonvipno:=0;
for i:=1 to planesno do
    if day[i].vip=true then begin vipno:=vipno+1;vipplanes[vipno]:=day[i];end;
for i:=1 to planesno do
    if day[i].vip=false then begin nonvipno:=nonvipno+1;nonvipplanes[nonvipno]:=day[i];end;

{now sort both vip/nonvip planes using selection sort :-)}
for i:=1 to vipno do
    for j:=i+1 to vipno do
        if vipplanes[j].time<vipplanes[i].time then
           begin tempplane:=vipplanes[j];
           vipplanes[j]:=vipplanes[i];vipplanes[i]:=tempplane;
           end;
for i:=1 to nonvipno do
    for j:=i+1 to nonvipno do
        if nonvipplanes[j].time<nonvipplanes[i].time then
           begin tempplane:=nonvipplanes[j];
           nonvipplanes[j]:=nonvipplanes[i];nonvipplanes[i]:=tempplane;
           end;

{now do arrange the vip then the nonvip on the airways}
for i:=1 to vipno do
    begin
    index:=trunc(vipplanes[i].time);
    index:=index*2+ord(index<vipplanes[i].time);
    for j:=index to 96 do
        for k:=1 to 2 do
            if airway[k][j].company=0 then
               begin
               airway[k][j]:=vipplanes[i];
               if j>maxindex then maxindex:=j;
               if j<>index then
                     postpone(airway[k,j],index);
               j:=96;k:=2; {bail outta this loop}
               end;
    end;

for i:=1 to nonvipno do
    begin
    index:=trunc(nonvipplanes[i].time);
    index:=index*2+ord(index<nonvipplanes[i].time);
    for j:=index to 96 do
        for k:=1 to 2 do
            if airway[k][j].company=0 then
               begin
               airway[k][j]:=nonvipplanes[i];
               if j>maxindex then maxindex:=j;
               if j<>index then
                     postpone(airway[k,j],index);
               j:=96;k:=2; {bail outta this loop}
               end;
    end;

end;
{****************************************************************************}
procedure displayplaneid(p:plane;time:real);
var timestr:string;
begin
setfillstyle(1,GREEN);
bar(34,314,296,447);
setcolor(BLACK);
outtextxy(40,317,'Plane company :');outtextxy(40,337,'Estimated time:');
outtextxy(40,357,'Vip Character :');outtextxy(40,377,'Action        :');
outtextxy(40,357,'Vip Character :');outtextxy(40,377,'Action        :');
outtextxy(40,397,'Heading from  :');outtextxy(40,417,'Destination   :');
setcolor(RED);
time2str(p.time,timestr);
outtextxy(30+130,317,companies[p.company]);
outtextxy(30+130,337,timestr);
if p.vip=true then outtextxy(30+130,357,p.vipname)
else  outtextxy(30+130,357,'none');
if p.takeoff=true then begin
                       outtextxy(30+130,377,'Taking off');
                       outtextxy(30+130,397,'Cairo');
                       outtextxy(30+130,417,countries[p.country]);
                       end
else                   begin
                       outtextxy(30+130,377,'Landing');
                       outtextxy(30+130,417,'Cairo');
                       outtextxy(30+130,397,countries[p.country]);
                       end;
end;
{****************************************************************************}
procedure display_map_marker(country:integer);
var img1,img2:array[1..200] of integer;
    i:integer;
    tc:char;
begin
while(not keypressed) do
begin
getimage(345+coords[country].x-5,315+coords[country].y-5,345+coords[country].x+5,315+coords[country].y+5,img1);
setcolor(RED);
circle(345+coords[country].x,315+coords[country].y,4);
circle(345+coords[country].x,315+coords[country].y,1);
circle(345+coords[country].x,315+coords[country].y,2);
arc(497,130,100,240,5);arc(497,130,100,240,9);
arc(497,130,100,240,13);arc(497,130,100,240,17);
for i:=200 to 202 do begin sound(i);delay(1);nosound;end;
delay(300);
putimage(345+coords[country].x-5,315+coords[country].y-5,img1,COPYPUT);
delay(300);
getimage(345+142-5,315+60-5,345+142+5,315+60+5,img2);
setcolor(RED);
circle(345+142,315+60,4);circle(345+142,315+60,1);circle(345+142,315+60,2);
setcolor(cyan);
arc(497,130,100,240,5);arc(497,130,100,240,9);
arc(497,130,100,240,13);arc(497,130,100,240,17);
delay(300);
putimage(345+142-5,315+60-5,img2,copyput);
end;
tc:=readkey;
end;
{****************************************************************************}
procedure writeplane2file(aeroplane:plane);
var st:string;
begin
writeln(tempfile,'Company:  '+companies[aeroplane.company]);
if aeroplane.takeoff=true then writeln(tempfile,'Arriving or Departing:'+'Departing')
   else writeln(tempfile,'Arriving or Departing:  '+'Arriving');
time2str(aeroplane.time,st);
writeln(tempfile,'Estimated Time:  ',st);
if aeroplane.vip then writeln(tempfile,'Vipname:  '+aeroplane.vipname)
   else writeln(tempfile,'Vipname:'+'none');
if aeroplane.takeoff then writeln(tempfile,'Destination:  '+countries[aeroplane.company])
   else writeln(tempfile,'Coming from:  '+countries[aeroplane.company])
end;
{****************************************************************************}
procedure handle_postponed(i:integer;time:real);
var ptr:groupptr;
    x:integer;
    planeimg:planeimage;
    fptr:file of planeimage;
    st:string;
begin
ptr:=postponed[i];
while ptr<>nil do
begin
setfillstyle(1,GREEN);
bar(34,314,296,416);
setcolor(BLUE);
displayplaneid(ptr^.aeroplane,0);
display_map_marker(ptr^.aeroplane.country);
assign(fptr,'p3');
reset(fptr);
read(fptr,planeimg);
close(fptr);
planeimg[3]:=planeimg[3]-1;planeimg[4]:=planeimg[4]-19;
writeln(tempfile,'');
time2str(time,st);
writeln(tempfile,st+': Plane Postponing');
writeplane2file(ptr^.aeroplane);
if ptr^.aeroplane.takeoff<>true then
begin
for x:=537 downto 35 do
    begin
    sound(300);delay(2);nosound;
    putimage(x,102,planeimg[3],copyPUT);
    sound(300);delay(1);nosound;
    end;
    for x:=1 to 69 do
    begin
    getimage(36,102,36+100,121,planeimg[3]);
    sound(350);delay(2);nosound;
    putimage(35,102,planeimg[3],normalPUT);
    sound(370);delay(2);nosound;
    end;
end;
ptr:=ptr^.next;
end;
end;
{****************************************************************************}
procedure planetakeland(aeroplane:plane;airway:integer;time:real);
var fptr:file of planeimage;
    planeimg:planeimage;
    x,y:integer;
    st:string;
begin
if aeroplane.takeoff=true then assign(fptr,'p4')
   else assign(fptr,'p3');
reset(fptr);
read(fptr,planeimg);
close(fptr);
planeimg[3]:=planeimg[3]-1;planeimg[4]:=planeimg[4]-19;
writeln(tempfile,'');
time2str(time,st);
if aeroplane.takeoff then writeln(tempfile,st+': Plane Taking off')
   else writeln(tempfile,st+': Plane Landing');
writeplane2file(aeroplane);
if aeroplane.takeoff=true then
   begin
   for x:=35 to 100 do
       begin
       sound(400);delay(2);nosound;
       putimage(x,200-(airway-1)*30,planeimg[3],normalPUT);
       sound(420);delay(2);nosound;
       end;
   for x:=100 to 425 do
        begin
        sound(400+(x-100)*20);delay(2);nosound;
        y:=230-trunc(0.3*x)-(airway-1)*30;
        putimage(x,y,planeimg[3],normalPUT);
        sound(420+(x-100)*15);delay(2);nosound;
        end;
   for x:=425 to 537 do
   begin
   sound(400+(x-100)*15);delay(2);nosound;
   putimage(x,102-(airway-1)*30,planeimg[3],normalPUT);
   sound(420+(x-100)*15);delay(2);nosound;
   end;
   y:=1;

   for x:=1 to 69 do
   begin
   getimage(537,102-(airway-1)*30,537+68,121-(airway-1)*30,planeimg[3]);
   sound(400+(537-100)*15);delay(3);nosound;
   putimage(538,102-(airway-1)*30,planeimg[3],normalPUT);
   sound(420+(536-100)*15);delay(3);nosound;
   end;
end
else
    begin
        for x:=537 downto 425 do
        begin
        sound(400+(x-100)*15);delay(2);nosound;
        putimage(x,102-(airway-1)*30,planeimg[3],normalPUT);
        sound(420+(x-100)*15);delay(2);nosound;end;
        for x:=425 downto 100 do
        begin
        sound(400+(x-100)*20);delay(2);nosound;
        y:=230-trunc(0.3*x)-(airway-1)*30;
        putimage(x,y,planeimg[3],normalPUT);
        sound(420+(x-100)*20);delay(2);nosound;
        end;
        for x:=100 downto 35 do
        begin
        sound(400);delay(2);nosound;
        putimage(x,200-(airway-1)*30,planeimg[3],normalPUT);
        sound(420);delay(2);nosound;
        end;
        for x:=1 to 69 do
        begin
        getimage(36,200-(airway-1)*30,36+100,219-(airway-1)*30,planeimg[3]);
        sound(400);delay(3);nosound;
        putimage(35,200-(airway-1)*30,planeimg[3],normalPUT);
        sound(420);delay(3);nosound;
        end;

end;
end;
{****************************************************************************}
procedure updatetimeairway(time:real;j,actno:integer);
var actions:array [0..3] of string[30];
    tst,timestr:string[40];
begin
actions[0]:='none';
actions[1]:='Plane landing';
actions[2]:='Plane taking off';
actions[3]:='Plane postponing';
setfillstyle(1,0);bar(33,273,87,292);
bar(133,273,187,292);
bar(233,273,437,293);
str(trunc(time),timestr);timestr:=timestr+':';
if time>trunc(time) then
                    begin
                    str(30,tst);
                    timestr:=timestr+tst;
                    end
else timestr:=timestr+'00';
setcolor(15);
outtextxy(44,279,timestr);
if j=0 then tst:='none'
       else str(j,tst);
outtextxy(152,279,tst);
outtextxy(238,279,actions[actno]);
if actno=0 then delay(200);
end;
{****************************************************************************}
procedure shaded_text(x,y,d,c1,c2:integer;st:string);
begin
setcolor(c1);outtextxy(x,y,st);
setcolor(c2);outtextxy(x-d,y-d,st);
end;
{****************************************************************************}
{procedure load_map(x,y:integer);
type img=array[1..8390] of integer;
var fptr:FILE of img;
    mapimg:^img;
    a:integer;
begin
assign(fptr,'map.dat');
reset(fptr);
new(mapimg);
read(fptr,mapimg^);
putimage(x,y,mapimg^,COPYPUT);
putimage(x+248,y,mapimg^[8126],COPYPUT);
close(fptr);
dispose(mapimg);
end;}
{****************************************************************************}
procedure updatescreencolor(i:integer);
var s:string;
begin
     i:=i mod 48;
     case (i) of
          0..14: setrgbpalette(CYAN,0,0,i*4);
          15..34:setrgbpalette(CYAN,0,0,63);
          35..48:setrgbpalette(CYAN,0,0,63-(i-35)*4);
          end;
end;
procedure display_check_items(x,y,no:integer);
var i,current:integer;
begin
for i:=1 to no do
    begin
    setcolor(15);
    frame3d(x,y+(i-1)*30,x+15,y+(i-1)*30+13,DARKGRAY,LIGHTGRAY);
    setcolor(0);
    setfillstyle(1,GREEN);
    bar(x+2,y+(i-1)*30+2,x+15-2,y+(i-1)*30+13-2);
    rectangle(x+2,y+(i-1)*30+2,x+15-2,y+(i-1)*30+13-2);
    settextstyle(1,0,1);
    outtextxy(x+30,y-6+(i-1)*30,menuoptions[i]);
    end;
end;
{****************************************************************************}
procedure checkbox(x,y,no:integer);
var i,current:integer;
    ch:char;
    ex:boolean;
begin
setcolor(RED);
setlinestyle(1,0,1);
i:=1;
rectangle(x+28,y+(i-1)*30-1,x+28+widths[i],y+(i-1)*30+15+2);

while (ex<>true) do
      begin
      ch:=readkey;
      case ch of
           #0: begin;ch:=readkey;end;
           #9: begin
               setcolor(GREEN);
               rectangle(x+28,y+(i-1)*30-1,x+28+widths[i],y+(i-1)*30+15+2);
               if (i<>no) then
               begin
               inc(i);
               setcolor(RED);
               rectangle(x+28,y+(i-1)*30-1,x+28+widths[i],y+(i-1)*30+15+2);
               end
               else ex:=true;
               end;
           #13 :
               begin
               if checks[i]=false then
                  begin
                  setcolor(0);
                  setlinestyle(0,0,3);
                  line(x+3,y+(i-1)*30+3,x+15-3,y+(i-1)*30+13-3);
                  line(x+3,y+(i-1)*30+13-3,x+15-3,y+(i-1)*30+3);
                  end
               else
                   begin
                   setfillstyle(1,GREEN);
                  bar(x+3,y+(i-1)*30+3,x+15-3,y+(i-1)*30+13-3);
                  end;
                  checks[i]:=checks[i] xor true;
                  setlinestyle(1,0,1);

               end;
           end;
      end;
setlinestyle(0,0,1);
end;
{****************************************************************************}
{Display Icon: this procedure loads the icon from the filename
 parameter and displays it then it displays the text in str param}
type iconimage=array[1..754] of integer;
{****************************************************************************}
procedure display_icon(x,y,font,size:integer;str,filename:string);
var fptr: file of iconimage;
        icnimg:iconimage;
begin
assign(fptr,filename);
reset(fptr);
read(fptr,icnimg);
close(fptr);
frame3d(x,y,x+100,y+60,darkgray,lightgray);
setcolor(0);
rectangle(x+2,y+2,x+98,y+58);
frame3d(x+3,y+3,x+97,y+57,lightgray,darkgray);
setcolor(green);
rectangle(x+6,y+6,x+94,y+54);
setcolor(0);
settextstyle(font,0,size);
if font=0 then outtextxy(x+60,y+25+8,str) else outtextxy(x+60,y+25,str);
setcolor(green);
putimage(x+14,y+20,icnimg[3],COPYPUT);
rectangle(x+14,y+20,x+14+icnimg[3],y+20+icnimg[4]);
end;
{****************************************************************************}
{ Check Icon: this function checks the keyboard, if tab was pressed
  it returns false and if enter was pressed it returns true and
  display the icon on the screen as if the button was pressed :-) }
function check_icon(x,y,width,font,size:integer;str,filename:string):boolean;
var ch:char;
    ex:boolean;
    fptr: file of iconimage;
    icnimg:iconimage;
    begin
assign(fptr,filename);reset(fptr);read(fptr,icnimg);close(fptr);
ex:=false;
setcolor(RED);
setlinestyle(1,0,1);
rectangle(x+54,y+50,x+54+width,y+27);
setlinestyle(font,0,1);
while (ex<>true) do
      begin
      ch:=readkey;
      if ch=#9 then begin {clear dotted line} ex:=true;check_icon:=false;end;
      if ch=#13 then begin
                     setcolor(DARKGRAY);
                     frame3d(x+3,y+3,x+97,y+57,darkgray,green);
                     setcolor(green);rectangle(x+6,y+6,x+94,y+54);
                     setcolor(darkgray);line(x+4,y+4,x+97,y+4);line(x+5,y+5,x+97,y+5);
                     line(x+4,y+4,x+4,y+58);line(x+3,y+4,x+3,y+58);line(x+5,y+4,x+5,y+58);
                     settextstyle(font,0,size);
                     if font=0 then outtextxy(x+63,y+27+8,str) else outtextxy(x+63,y+27,str);
                     setcolor(0);
                     if font=0 then outtextxy(x+60,y+25+8,str) else outtextxy(x+60,y+25,str);
                     setfillstyle(1,GREEN);
                     setcolor(green);
                     bar(x+14,y+20,x+54,y+50);
                     putimage(x+17,y+23,icnimg[3],COPYPUT);
                     rectangle(x+17,y+23,x+17+icnimg[3],y+23+icnimg[4]);
                     setlinestyle(1,0,1);setcolor(RED);
                     rectangle(x+54,y+50,x+54+width,y+27);
                     setlinestyle(0,0,1);
                     delay(600);
                     setfillstyle(1,GREEN);
                     bar(x,y,x+100,y+60);
                     frame3d(x,y,x+100,y+60,darkgray,lightgray);
                     setcolor(0);
                     rectangle(x+2,y+2,x+98,y+58);
                     frame3d(x+3,y+3,x+97,y+57,lightgray,darkgray);
                     setcolor(green);rectangle(x+6,y+6,x+94,y+54);
                     setcolor(black);
                     if font=0 then outtextxy(x+60,y+25+8,str) else outtextxy(x+60,y+25,str);
                     ex:=true;check_icon:=true;
                     setcolor(green);
                     putimage(x+14,y+20,icnimg[3],COPYPUT);
                     rectangle(x+14,y+20,x+14+icnimg[3],y+20+icnimg[4]);
                     setlinestyle(1,0,1);setcolor(RED);
                     rectangle(x+54,y+50,x+54+width,y+27);
                     setlinestyle(0,0,1);
                     delay(500);
                     end;
      if ch=#0 then ch:=readkey;
      end;
setcolor(green);
setlinestyle(1,0,1);
rectangle(x+54,y+50,x+54+width,y+27);
setlinestyle(0,0,1);
end;
{****************************************************************************}
{Write report to file: this procedure exports the report found in the
 'report.tmp' to another file specified by the user. }
procedure writereport2file(filename:string);
var inp,out:text;
    st:string;
    i:integer;
begin
assign(inp,'report.tmp');
reset(inp);
if (filename<>'prn') and (filename<>'con') then assign(out,filename+'.rpt')
else assign(out,filename);
rewrite(out);
readln(inp,st);
if filename<>'con' then writeln(out,st);
while not eof(inp) do
      begin
      if(filename='con') then
                         begin
                         window(3,4,78,20);
                         clrscr;
                         frame(20,5,60,15,blue);
                         transline(20,7,41);
                         gotoxy(34,6);write('Current Plane');
                         end;
      for i:=1 to 7 do
      begin
      readln(inp,st);
      if filename='con' then gotoxy(22,6+i);writeln(out,st);
      end;
      if filename='con' then wait4akey;
      end;
close(inp);close(out);
end;
{****************************************************************************}
{End of Simulation: After the end of simulation, this procedure is
 called . It displays a check box for the 3 choices of the report,
 then calls the procedure writereport2file to export the report
 either to screen , file or printer}
procedure eos;
var ex:boolean;
    i:integer;
begin
setfillstyle(1,GREEN);
bar(150,0,490,479);
frame3d(150,0,490,479,LIGHTGRAY,DARKGRAY);
setcolor(LIGHTGRAY);rectangle(170,20,470,459);
setcolor(DARKGRAY);rectangle(169,19,471,460);
settextstyle(3,0,4);
setcolor(LIGHTGRAY);outtextxy(190,20,'End Of Simulation');
setcolor(RED);outtextxy(189,19,'End Of Simulation');
menuoptions[1]:='Write report on a File';
menuoptions[2]:='Display report on screen';
menuoptions[3]:='Print report (Hard Copy)';
checks[1]:=false;checks[2]:=false;checks[3]:=false;
widths[1]:=230;widths[2]:=212;widths[3]:=230;
display_check_items(195,90,3);
ex:=false;
display_icon(265,180,3,2,'Ok','r');
while ex<>true do
      begin
      checkbox(195,90,3);
      ex:=check_icon(265,180,35,3,2,'Ok','r');
      end;
if checks[1]=true then
            begin
            setcolor(DARKGRAY);line(210,270,426,270);
            setcolor(LIGHTGRAY);line(211,271,427,271);
            frame3d(228,328,408,358,DARKGRAY,LIGHTGRAY);
            setfillstyle(1,0);bar(231,331,405,355);
            setcolor(0);outtextxy(230,300,'Enter file name');
            writereport2file(input_text(234,328,8));
            end;
if checks[2]=true then
                  begin
                  closegraph;
                  textmode(3);
                  frame(1,1,79,25,BLUE);
                  transline(1,3,79);
                  gotoxy(35,2);write('Todays Report');
                  transline(1,23,79);
                  gotoxy(29,24);write('Press any key to continue');
                  writereport2file('con');
                  window(1,1,80,25);
                  end;
if checks[3]=true then writereport2file('prn');
end;
{****************************************************************************}
{Airport Simulation:Displays the airport's background then starts a
 loop that passes on the array of the airway then if a plane was found
 in any element make it take off or land or postponed by calling the
 procedures planetakeland and handle_postponed}
procedure simulate_airport;
var i,j,x,y,m,gdriver,gmode:integer;
    fptr:file of planeimage;
        tempstr:tempstring;
    planeimg:planeimage;
    time:real;
    timestr,tst:string[40];
begin
gdriver:=VGA;gmode:=VGAHI;
initgraph(gdriver,gmode,'\tp\egavga.bgi');
setrgbpalette(GREEN,37,37,37);setfillstyle(1,GREEN);
bar(4,4,635,475);
frame3d(0,0,639,479,LIGHTGRAY,DARKGRAY);
setcolor(LIGHTGRAY);rectangle(21,21,620,459);
setcolor(DARKGRAY);rectangle(20,20,619,458);
frame3d(30,30,610,250,DARKGRAY,LIGHTGRAY); {Marked!}
setfillstyle(1,CYAN);bar(34,34,606,246);
setrgbpalette(CYAN,20,20,63);
frame3d(30,310,300,451,DARKGRAY,LIGHTGRAY);
frame3d(341,311,602,451,DARKGRAY,LIGHTGRAY);
assign(fptr,'p3');reset(fptr);read(fptr,planeimg);close(fptr);
setcolor(white);
line(400,160,440,247);line(400,160,607,160);
line(606,160,606,246);line(606,246,440,246);
setfillstyle(1,black);floodfill(430,179,15);
putimage(494,169,planeimg[3],COPYPUT);
putimage(498,189,planeimg[3],COPYPUT);
putimage(434,169,planeimg[3],COPYPUT);
putimage(438,189,planeimg[3],COPYPUT);
line(419,173,606,173);
line(419,173,443,222);
line(443,222,606,222);
setfillstyle(1,black);floodfill(430,179,15);
floodfill(530,178,15);
floodfill(500,178,15);
floodfill(560,178,15);
setfillstyle(closedotfill,LIGHTGREEN);
floodfill(405,165,white);
i:=0;x:=400;y:=100;
setcolor(darkgray);
line(500,150,495,240);line(515,150,520,240);
line(500,150,515,150);line(520,240,495,240);
rectangle(498,135,517,150);
setfillstyle(1,0);
bar(500,137,515,148);
setcolor(LIGHTGRAY);rectangle(507,132,509,135);
setfillstyle(XHATCHFILL,DARKGRAY);floodfill(508,158,DARKGRAY);
setcolor(BROWN);
rectangle(35,222,122,223);rectangle(35,192,122,193);
shaded_text(31,261,1,LIGHTGRAY,DARKGRAY,'Time');
shaded_text(130,261,1,LIGHTGRAY,DARKGRAY,'Airway');
shaded_text(230,261,1,LIGHTGRAY,DARKGRAY,'Action');
frame3d(30,270,90,295,DARKGRAY,LIGHTGRAY);
setfillstyle(1,0);bar(33,273,87,292);
frame3d(130,270,190,295,DARKGRAY,LIGHTGRAY);
setfillstyle(1,0);bar(133,273,187,292);
frame3d(230,270,440,295,DARKGRAY,LIGHTGRAY);
setfillstyle(1,0);bar(233,273,437,293);
frame3d(476,270,610,295,DARKGRAY,LIGHTGRAY);
setfillstyle(1,15);bar(479,273,607,292);
shaded_text(492,278,1,RED,LIGHTRED,'Cairo Airport');
load_map(345,315);
setcolor(0);rectangle(345,315,598,446);
j:=0;
assign(tempfile,'report.tmp');
rewrite(tempfile);
tempstr:='Report for todays Airport simulation';
writeln(tempfile,tempstr);
for i:=1 to maxindex do
    begin
    time:=i/2;
    updatescreencolor(i);
    if airway[1][i].company<>0 then begin
                                    updatetimeairway(time,0,3);
                                    handle_postponed(i,time);
                                    end;
    for j:=1 to 2 do
        if airway[j][i].company<>0 then
           begin
           updatetimeairway(time,j,ord(airway[j][i].takeoff)+1);
           displayplaneid(airway[j][i],time);
           display_map_marker(airway[j][i].country);
           planetakeland(airway[j][i],j,time);
           end
        else updatetimeairway(time,0,0);
    end;
close(tempfile);
eos; {end of simulation}
closegraph;
end;
{****************************************************************************}
{Displays the main menu icons and waits for a choice then returns it to
 the main procedure}
function main_menu : integer;
type ic=record
     x,y:integer;
     caption,fn:string;
     end;
var current,g,gd:integer;

    ex:boolean;
    icons:array[1..8] of ic;
    help:array[1..9] of string;
begin
clrscr;
g:=VGA;gd:=VGAHI;
initgraph(g,gd,'');
setrgbpalette(GREEN,37,37,37);
frame3d(0,0,639,479,lightgray,darkgray);
setfillstyle(1,GREEN);
bar(3,3,636,476);
setcolor(BLUE);settextstyle(1,0,5);outtextxy(229,0,'Main Menu');
setcolor(darkgray);line(20,60,628-10,60);
setcolor(lightgray);line(21,61,629-10,61);
ex:=false;
help[1]:='Add a plane in todays time table';
help[2]:='Edit a plane in todays time table';
help[3]:='Deletes a plane in todays time table';
help[4]:='Displays today time table';
help[5]:='Load the time table from a file';
help[6]:='Save the time table to a file';
help[7]:='Start the simulation';
help[8]:='Exit from the program';
icons[1].x:=30;icons[1].y:=80;icons[1].caption:='Add';icons[1].fn:='add';
icons[2].x:=130;icons[2].y:=80;icons[2].caption:='Edit';icons[2].fn:='edit';
icons[3].x:=30;icons[3].y:=140;icons[3].caption:='Del';icons[3].fn:='del';
icons[4].x:=130;icons[4].y:=140;icons[4].caption:='List';icons[4].fn:='dsp';
icons[5].x:=30;icons[5].y:=200;icons[5].caption:='Load';icons[5].fn:='rd';
icons[6].x:=130;icons[6].y:=200;icons[6].caption:='Save';icons[6].fn:='sv';
icons[7].x:=30;icons[7].y:=260;icons[7].caption:='Go';icons[7].fn:='r';
icons[8].x:=130;icons[8].y:=260;icons[8].caption:='Exit';icons[8].fn:='ex';
for current:=1 to 8 do
    begin
    display_icon(icons[current].x,icons[current].y,0,1,icons[current].caption,icons[current].fn);
    end;
      frame3d(272,127,588,202,darkgray,lightgray);
      setfillstyle(1,black);bar(275,130,585,199);
      setcolor(YELLOW);outtextxy(290,135,'Press:');
      setcolor(Red);outtextxy(320,155,'Tab ');outtextxy(320,175,'Enter ');
      setcolor(15);outtextxy(355,155,'to move through options');
      outtextxy(370,175,'to choose');
      frame3d(272,215,588,377,darkgray,lightgray);
      setfillstyle(1,black);bar(275,218,585,374);
      setcolor(Red);outtextxy(368,230,'Airport Simulator');
      setcolor(Yellow);outtextxy(397,250,'Supervision');
      setcolor(15);outtextxy(368,270,'Dr. Nevin Darwish');
      setcolor(yellow);outtextxy(429,290,'BY');
      setcolor(white);
      outtextxy(367,310,'Ahmed Mohamed Reda');
      outtextxy(352,330,'ahmed@phish.nether.net');
      outtextxy(280,350,'http://www.geopages.com/Hollywood/1617');
current:=0;
while ex=false do
      begin
      inc(current);
      if current=9 then current:=1;
      frame3d(272,84,588,117,darkgray,lightgray);
      setfillstyle(1,black);bar(275,87,585,114);
      setcolor(white);
      outtextxy(290,95,help[current]);
      ex:=check_icon(icons[current].x,icons[current].y,40,0,1,icons[current].caption,icons[current].fn);
      end;
main_menu:=current;
end;
{****************************************************************************}
procedure start_simulation;
begin
arrange_airways;
simulate_airport;
end;
{****************************MAIN PROCEDURE**********************************}
begin
planesno:=0;
companies[1]:='Egypt Air';companies[2]:='Aeroloyd';
companies[3]:='Lufthansa';companies[4]:='Gulf Air';
countries[1]:='Austrailia';countries[2]:='Bulgaria';countries[3]:='Canada';
countries[4]:='Denemark';countries[5]:='England';countries[6]:='France';
countries[7]:='Germany';countries[8]:='Hungary';countries[9]:='Ireland';
countries[10]:='Japan';countries[11]:='Kuwait';countries[12]:='Malaysia';
countries[13]:='Netherland';countries[14]:='Pakistan';countries[15]:='Qatar';
countries[16]:='Russia';countries[17]:='Sweden';countries[18]:='U.S.A.';
countries[19]:='Vietnam';countries[20]:='Yugoslavia';countries[21]:='Zaire';
coords[1].x:=224;coords[1].y:=100;coords[2].x:=143;coords[2].y:=45;
coords[3].x:=45;coords[3].y:=25;coords[4].x:=120;coords[4].y:=34;
coords[5].x:=120;coords[5].y:=30;coords[6].x:=117;coords[6].y:=39;
coords[7].x:=130;coords[7].y:=32;coords[8].x:=135;coords[8].y:=37;
coords[9].x:=112;coords[9].y:=33;coords[10].x:=222;coords[10].y:=52;
coords[11].x:=160;coords[11].y:=55;coords[12].x:=200;coords[12].y:=70;
coords[13].x:=119;coords[14].y:=36;coords[14].x:=169;coords[14].y:=52;
coords[15].x:=158;coords[15].y:=57;coords[16].x:=224;coords[16].y:=100;
coords[17].x:=125;coords[17].y:=31;coords[18].x:=45;coords[18].y:=44;
coords[19].x:=205;coords[19].y:=64;coords[20].x:=135;coords[20].y:=44;
coords[21].x:=135;coords[21].y:=80;
initialize_graph;
intro;
while true do
begin
choice:=main_menu;
case choice of
     1: begin closegraph;textmode(3);add_plane(0); end;
     2: edit_plane;
     3: delete_plane;
     4: begin display_planes;wait4akey; end;
     5: begin
        setfillstyle(1,green);bar(180,180,456,280);
        frame3d(180,180,456,280,darkgray,lightgray);
        frame3d(228,228,408,258,DARKGRAY,LIGHTGRAY);
        setfillstyle(1,0);bar(231,231,405,255);
        setcolor(0);outtextxy(230,200,'Enter file name');
        load_day(input_text(234,228,8));
        end;
     6: begin
        setfillstyle(1,green);bar(180,180,456,280);
        frame3d(180,180,456,280,darkgray,lightgray);
        frame3d(228,228,408,258,DARKGRAY,LIGHTGRAY);
        setfillstyle(1,0);bar(231,231,405,255);
        setcolor(0);outtextxy(230,200,'Enter file name');
        save_day(input_text(234,228,8));
        end;
     7: start_simulation;
     8: begin closegraph;textmode(3);exit;end;
     end;
end;
end.
